import { resetComponent as f, genFocusStyle as b } from "../../style/index.mjs";
import { initMoveMotion as w } from "../../style/motion/move.mjs";
import { slideUpIn as S, slideDownIn as h, slideUpOut as x, slideDownOut as z, initSlideMotion as v } from "../../style/motion/slide.mjs";
import { initZoomMotion as C } from "../../style/motion/zoom.mjs";
import y, { getArrowOffset as I } from "../../style/placementArrow.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import P from "../../theme/util/genComponentStyleHook.mjs";
import { merge as R } from "../../theme/util/statistic.mjs";
import O from "./status.mjs";
const A = (o) => {
  const {
    componentCls: i,
    menuCls: t,
    zIndexPopup: d,
    dropdownArrowDistance: c,
    sizePopupArrow: u,
    antCls: e,
    iconCls: n,
    motionDurationMid: r,
    dropdownPaddingVertical: p,
    fontSize: s,
    dropdownEdgeChildPadding: $,
    colorTextDisabled: l,
    fontSizeIcon: a,
    controlPaddingHorizontal: g,
    colorBgElevated: m
  } = o;
  return [
    {
      [i]: Object.assign(Object.assign({}, f(o)), {
        position: "absolute",
        top: -9999,
        left: {
          _skip_check_: !0,
          value: -9999
        },
        zIndex: d,
        display: "block",
        // A placeholder out of dropdown visible range to avoid close when user moving
        "&::before": {
          position: "absolute",
          insetBlock: -c + u / 2,
          // insetInlineStart: -7, // FIXME: Seems not work for hidden element
          zIndex: -9999,
          opacity: 1e-4,
          content: '""'
        },
        [`&-trigger${e}-btn`]: {
          [`& > ${n}-down, & > ${e}-btn-icon > ${n}-down`]: {
            fontSize: a
          }
        },
        [`${i}-wrap`]: {
          position: "relative",
          [`${e}-btn > ${n}-down`]: {
            fontSize: a
          },
          [`${n}-down::before`]: {
            transition: `transform ${r}`
          }
        },
        [`${i}-wrap-open`]: {
          [`${n}-down::before`]: {
            transform: "rotate(180deg)"
          }
        },
        "\n        &-hidden,\n        &-menu-hidden,\n        &-menu-submenu-hidden\n      ": {
          display: "none"
        },
        // =============================================================
        // ==                         Motion                          ==
        // =============================================================
        // When position is not enough for dropdown, the placement will revert.
        // We will handle this with revert motion name.
        [`&${e}-slide-down-enter${e}-slide-down-enter-active${i}-placement-bottomLeft,
          &${e}-slide-down-appear${e}-slide-down-appear-active${i}-placement-bottomLeft,
          &${e}-slide-down-enter${e}-slide-down-enter-active${i}-placement-bottom,
          &${e}-slide-down-appear${e}-slide-down-appear-active${i}-placement-bottom,
          &${e}-slide-down-enter${e}-slide-down-enter-active${i}-placement-bottomRight,
          &${e}-slide-down-appear${e}-slide-down-appear-active${i}-placement-bottomRight`]: {
          animationName: S
        },
        [`&${e}-slide-up-enter${e}-slide-up-enter-active${i}-placement-topLeft,
          &${e}-slide-up-appear${e}-slide-up-appear-active${i}-placement-topLeft,
          &${e}-slide-up-enter${e}-slide-up-enter-active${i}-placement-top,
          &${e}-slide-up-appear${e}-slide-up-appear-active${i}-placement-top,
          &${e}-slide-up-enter${e}-slide-up-enter-active${i}-placement-topRight,
          &${e}-slide-up-appear${e}-slide-up-appear-active${i}-placement-topRight`]: {
          animationName: h
        },
        [`&${e}-slide-down-leave${e}-slide-down-leave-active${i}-placement-bottomLeft,
          &${e}-slide-down-leave${e}-slide-down-leave-active${i}-placement-bottom,
          &${e}-slide-down-leave${e}-slide-down-leave-active${i}-placement-bottomRight`]: {
          animationName: x
        },
        [`&${e}-slide-up-leave${e}-slide-up-leave-active${i}-placement-topLeft,
          &${e}-slide-up-leave${e}-slide-up-leave-active${i}-placement-top,
          &${e}-slide-up-leave${e}-slide-up-leave-active${i}-placement-topRight`]: {
          animationName: z
        }
      })
    },
    // =============================================================
    // ==                        Arrow style                      ==
    // =============================================================
    y(o, {
      colorBg: m,
      limitVerticalRadius: !0,
      arrowPlacement: {
        top: !0,
        bottom: !0
      }
    }),
    {
      // =============================================================
      // ==                          Menu                           ==
      // =============================================================
      [`${i} ${t}`]: {
        position: "relative",
        margin: 0
      },
      [`${t}-submenu-popup`]: {
        position: "absolute",
        zIndex: d,
        background: "transparent",
        boxShadow: "none",
        transformOrigin: "0 0",
        "ul, li": {
          listStyle: "none",
          margin: 0
        }
      },
      [`${i}, ${i}-menu-submenu`]: {
        [t]: Object.assign(Object.assign({
          padding: $,
          listStyleType: "none",
          backgroundColor: m,
          backgroundClip: "padding-box",
          borderRadius: o.borderRadiusLG,
          outline: "none",
          boxShadow: o.boxShadowSecondary
        }, b(o)), {
          [`${t}-item-group-title`]: {
            padding: `${p}px ${g}px`,
            color: o.colorTextDescription,
            transition: `all ${r}`
          },
          // ======================= Item Content =======================
          [`${t}-item`]: {
            position: "relative",
            display: "flex",
            alignItems: "center"
          },
          [`${t}-item-icon`]: {
            minWidth: s,
            marginInlineEnd: o.marginXS,
            fontSize: o.fontSizeSM
          },
          [`${t}-title-content`]: {
            flex: "auto",
            "> a": {
              color: "inherit",
              transition: `all ${r}`,
              "&:hover": {
                color: "inherit"
              },
              "&::after": {
                position: "absolute",
                inset: 0,
                content: '""'
              }
            }
          },
          // =========================== Item ===========================
          [`${t}-item, ${t}-submenu-title`]: Object.assign(Object.assign({
            clear: "both",
            margin: 0,
            padding: `${p}px ${g}px`,
            color: o.colorText,
            fontWeight: "normal",
            fontSize: s,
            lineHeight: o.lineHeight,
            cursor: "pointer",
            transition: `all ${r}`,
            borderRadius: o.borderRadiusSM,
            "&:hover, &-active": {
              backgroundColor: o.controlItemBgHover
            }
          }, b(o)), {
            "&-selected": {
              color: o.colorPrimary,
              backgroundColor: o.controlItemBgActive,
              "&:hover, &-active": {
                backgroundColor: o.controlItemBgActiveHover
              }
            },
            "&-disabled": {
              color: l,
              cursor: "not-allowed",
              "&:hover": {
                color: l,
                backgroundColor: m,
                cursor: "not-allowed"
              },
              a: {
                pointerEvents: "none"
              }
            },
            "&-divider": {
              height: 1,
              margin: `${o.marginXXS}px 0`,
              overflow: "hidden",
              lineHeight: 0,
              backgroundColor: o.colorSplit
            },
            [`${i}-menu-submenu-expand-icon`]: {
              position: "absolute",
              insetInlineEnd: o.paddingXS,
              [`${i}-menu-submenu-arrow-icon`]: {
                marginInlineEnd: "0 !important",
                color: o.colorTextDescription,
                fontSize: a,
                fontStyle: "normal"
              }
            }
          }),
          [`${t}-item-group-list`]: {
            margin: `0 ${o.marginXS}px`,
            padding: 0,
            listStyle: "none"
          },
          [`${t}-submenu-title`]: {
            paddingInlineEnd: g + o.fontSizeSM
          },
          [`${t}-submenu-vertical`]: {
            position: "relative"
          },
          [`${t}-submenu${t}-submenu-disabled ${i}-menu-submenu-title`]: {
            [`&, ${i}-menu-submenu-arrow-icon`]: {
              color: l,
              backgroundColor: m,
              cursor: "not-allowed"
            }
          },
          // https://github.com/ant-design/ant-design/issues/19264
          [`${t}-submenu-selected ${i}-menu-submenu-title`]: {
            color: o.colorPrimary
          }
        })
      }
    },
    // Follow code may reuse in other components
    [v(o, "slide-up"), v(o, "slide-down"), w(o, "move-up"), w(o, "move-down"), C(o, "zoom-big")]
  ];
}, J = P("Dropdown", (o, i) => {
  let {
    rootPrefixCls: t
  } = i;
  const {
    marginXXS: d,
    sizePopupArrow: c,
    controlHeight: u,
    fontSize: e,
    lineHeight: n,
    paddingXXS: r,
    componentCls: p,
    borderRadiusLG: s
  } = o, $ = (u - e * n) / 2, {
    dropdownArrowOffset: l
  } = I({
    contentRadius: s
  }), a = R(o, {
    menuCls: `${p}-menu`,
    rootPrefixCls: t,
    dropdownArrowDistance: c / 2 + d,
    dropdownArrowOffset: l,
    dropdownPaddingVertical: $,
    dropdownEdgeChildPadding: r
  });
  return [A(a), O(a)];
}, (o) => ({
  zIndexPopup: o.zIndexPopupBase + 50
}));
export {
  J as default
};
