import { initComponentToken as v, initInputToken as B, genBasicInputStyle as h, genStatusStyle as $, genInputGroupStyle as C, genDisabledStyle as z, genPlaceholderStyle as A } from "../../input/style/index.mjs";
import { resetComponent as s, resetIcon as W } from "../../style/index.mjs";
import { genCompactItemStyle as G } from "../../style/compact-item.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import H from "../../theme/util/genComponentStyleHook.mjs";
import { merge as M } from "../../theme/util/statistic.mjs";
const g = (e, n) => {
  let {
    componentCls: i,
    borderRadiusSM: t,
    borderRadiusLG: o
  } = e;
  const r = n === "lg" ? o : t;
  return {
    [`&-${n}`]: {
      [`${i}-handler-wrap`]: {
        borderStartEndRadius: r,
        borderEndEndRadius: r
      },
      [`${i}-handler-up`]: {
        borderStartEndRadius: r
      },
      [`${i}-handler-down`]: {
        borderEndEndRadius: r
      }
    }
  };
}, T = (e) => {
  const {
    componentCls: n,
    lineWidth: i,
    lineType: t,
    colorBorder: o,
    borderRadius: r,
    fontSizeLG: a,
    controlHeightLG: l,
    controlHeightSM: m,
    colorError: f,
    paddingInlineSM: S,
    colorTextDescription: p,
    motionDurationMid: d,
    handleHoverColor: x,
    paddingInline: w,
    paddingBlock: y,
    handleBg: I,
    handleActiveBg: R,
    colorTextDisabled: j,
    borderRadiusSM: c,
    borderRadiusLG: u,
    controlWidth: O,
    handleVisible: E,
    handleBorderColor: b
  } = e;
  return [
    {
      [n]: Object.assign(Object.assign(Object.assign(Object.assign({}, s(e)), h(e)), $(e, n)), {
        display: "inline-block",
        width: O,
        margin: 0,
        padding: 0,
        border: `${i}px ${t} ${o}`,
        borderRadius: r,
        "&-rtl": {
          direction: "rtl",
          [`${n}-input`]: {
            direction: "rtl"
          }
        },
        "&-lg": {
          padding: 0,
          fontSize: a,
          borderRadius: u,
          [`input${n}-input`]: {
            height: l - 2 * i
          }
        },
        "&-sm": {
          padding: 0,
          borderRadius: c,
          [`input${n}-input`]: {
            height: m - 2 * i,
            padding: `0 ${S}px`
          }
        },
        // ===================== Out Of Range =====================
        "&-out-of-range": {
          [`${n}-input-wrap`]: {
            input: {
              color: f
            }
          }
        },
        // Style for input-group: input with label, with button or dropdown...
        "&-group": Object.assign(Object.assign(Object.assign({}, s(e)), C(e)), {
          "&-wrapper": {
            display: "inline-block",
            textAlign: "start",
            verticalAlign: "top",
            [`${n}-affix-wrapper`]: {
              width: "100%"
            },
            // Size
            "&-lg": {
              [`${n}-group-addon`]: {
                borderRadius: u,
                fontSize: e.fontSizeLG
              }
            },
            "&-sm": {
              [`${n}-group-addon`]: {
                borderRadius: c
              }
            },
            [`${n}-wrapper-disabled > ${n}-group-addon`]: Object.assign({}, z(e))
          }
        }),
        [`&-disabled ${n}-input`]: {
          cursor: "not-allowed"
        },
        [n]: {
          "&-input": Object.assign(Object.assign(Object.assign(Object.assign({}, s(e)), {
            width: "100%",
            padding: `${y}px ${w}px`,
            textAlign: "start",
            backgroundColor: "transparent",
            border: 0,
            borderRadius: r,
            outline: 0,
            transition: `all ${d} linear`,
            appearance: "textfield",
            fontSize: "inherit"
          }), A(e.colorTextPlaceholder)), {
            '&[type="number"]::-webkit-inner-spin-button, &[type="number"]::-webkit-outer-spin-button': {
              margin: 0,
              /* stylelint-disable-next-line property-no-vendor-prefix */
              webkitAppearance: "none",
              appearance: "none"
            }
          })
        }
      })
    },
    // Handler
    {
      [n]: Object.assign(Object.assign(Object.assign({
        [`&:hover ${n}-handler-wrap, &-focused ${n}-handler-wrap`]: {
          opacity: 1
        },
        [`${n}-handler-wrap`]: {
          position: "absolute",
          insetBlockStart: 0,
          insetInlineEnd: 0,
          width: e.handleWidth,
          height: "100%",
          background: I,
          borderStartStartRadius: 0,
          borderStartEndRadius: r,
          borderEndEndRadius: r,
          borderEndStartRadius: 0,
          opacity: E === !0 ? 1 : 0,
          display: "flex",
          flexDirection: "column",
          alignItems: "stretch",
          transition: `opacity ${d} linear ${d}`,
          // Fix input number inside Menu makes icon too large
          // We arise the selector priority by nest selector here
          // https://github.com/ant-design/ant-design/issues/14367
          [`${n}-handler`]: {
            display: "flex",
            alignItems: "center",
            justifyContent: "center",
            flex: "auto",
            height: "40%",
            [`
              ${n}-handler-up-inner,
              ${n}-handler-down-inner
            `]: {
              marginInlineEnd: 0,
              fontSize: e.handleFontSize
            }
          }
        },
        [`${n}-handler`]: {
          height: "50%",
          overflow: "hidden",
          color: p,
          fontWeight: "bold",
          lineHeight: 0,
          textAlign: "center",
          cursor: "pointer",
          borderInlineStart: `${i}px ${t} ${b}`,
          transition: `all ${d} linear`,
          "&:active": {
            background: R
          },
          // Hover
          "&:hover": {
            height: "60%",
            [`
              ${n}-handler-up-inner,
              ${n}-handler-down-inner
            `]: {
              color: x
            }
          },
          "&-up-inner, &-down-inner": Object.assign(Object.assign({}, W()), {
            color: p,
            transition: `all ${d} linear`,
            userSelect: "none"
          })
        },
        [`${n}-handler-up`]: {
          borderStartEndRadius: r
        },
        [`${n}-handler-down`]: {
          borderBlockStart: `${i}px ${t} ${b}`,
          borderEndEndRadius: r
        }
      }, g(e, "lg")), g(e, "sm")), {
        // Disabled
        "&-disabled, &-readonly": {
          [`${n}-handler-wrap`]: {
            display: "none"
          },
          [`${n}-input`]: {
            color: "inherit"
          }
        },
        [`
          ${n}-handler-up-disabled,
          ${n}-handler-down-disabled
        `]: {
          cursor: "not-allowed"
        },
        [`
          ${n}-handler-up-disabled:hover &-handler-up-inner,
          ${n}-handler-down-disabled:hover &-handler-down-inner
        `]: {
          color: j
        }
      })
    },
    // Border-less
    {
      [`${n}-borderless`]: {
        borderColor: "transparent",
        boxShadow: "none",
        [`${n}-handler-down`]: {
          borderBlockStartWidth: 0
        }
      }
    }
  ];
}, L = (e) => {
  const {
    componentCls: n,
    paddingBlock: i,
    paddingInline: t,
    inputAffixPadding: o,
    controlWidth: r,
    borderRadiusLG: a,
    borderRadiusSM: l
  } = e;
  return {
    [`${n}-affix-wrapper`]: Object.assign(Object.assign(Object.assign({}, h(e)), $(e, `${n}-affix-wrapper`)), {
      // or number handler will cover form status
      position: "relative",
      display: "inline-flex",
      width: r,
      padding: 0,
      paddingInlineStart: t,
      "&-lg": {
        borderRadius: a
      },
      "&-sm": {
        borderRadius: l
      },
      [`&:not(${n}-affix-wrapper-disabled):hover`]: {
        zIndex: 1
      },
      "&-focused, &:focus": {
        zIndex: 1
      },
      [`&-disabled > ${n}-disabled`]: {
        background: "transparent"
      },
      [`> div${n}`]: {
        width: "100%",
        border: "none",
        outline: "none",
        [`&${n}-focused`]: {
          boxShadow: "none !important"
        }
      },
      [`input${n}-input`]: {
        padding: `${i}px 0`
      },
      "&::before": {
        display: "inline-block",
        width: 0,
        visibility: "hidden",
        content: '"\\a0"'
      },
      [`${n}-handler-wrap`]: {
        zIndex: 2
      },
      [n]: {
        "&-prefix, &-suffix": {
          display: "flex",
          flex: "none",
          alignItems: "center",
          pointerEvents: "none"
        },
        "&-prefix": {
          marginInlineEnd: o
        },
        "&-suffix": {
          position: "absolute",
          insetBlockStart: 0,
          insetInlineEnd: 0,
          zIndex: 1,
          height: "100%",
          marginInlineEnd: t,
          marginInlineStart: o
        }
      }
    })
  };
}, nn = H("InputNumber", (e) => {
  const n = M(e, B(e));
  return [
    T(n),
    L(n),
    // =====================================================
    // ==             Space Compact                       ==
    // =====================================================
    G(n)
  ];
}, (e) => Object.assign(Object.assign({}, v(e)), {
  controlWidth: 90,
  handleWidth: e.controlHeightSM - e.lineWidth * 2,
  handleFontSize: e.fontSize / 2,
  handleVisible: "auto",
  handleActiveBg: e.colorFillAlter,
  handleBg: e.colorBgContainer,
  handleHoverColor: e.colorPrimary,
  handleBorderColor: e.colorBorder
}));
export {
  nn as default,
  g as genRadiusStyle
};
