import { clearFix as z, resetComponent as R, resetIcon as j } from "../../style/index.mjs";
import { initSlideMotion as D } from "../../style/motion/slide.mjs";
import { initZoomMotion as L } from "../../style/motion/zoom.mjs";
import W from "../../style/motion/collapse.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import E from "../../theme/util/genComponentStyleHook.mjs";
import { merge as k } from "../../theme/util/statistic.mjs";
import X from "./horizontal.mjs";
import G from "./rtl.mjs";
import w from "./theme.mjs";
import P from "./vertical.mjs";
import { TinyColor as y } from "../../../../@ctrl/tinycolor/dist/module/index.mjs";
const A = (n) => {
  const {
    componentCls: a,
    motionDurationSlow: e,
    motionDurationMid: o,
    motionEaseInOut: t,
    motionEaseOut: r,
    iconCls: i,
    iconSize: m,
    iconMarginInlineEnd: d
  } = n;
  return {
    // >>>>> Item
    [`${a}-item, ${a}-submenu-title`]: {
      position: "relative",
      display: "block",
      margin: 0,
      whiteSpace: "nowrap",
      cursor: "pointer",
      transition: [`border-color ${e}`, `background ${e}`, `padding ${e} ${t}`].join(","),
      [`${a}-item-icon, ${i}`]: {
        minWidth: m,
        fontSize: m,
        transition: [`font-size ${o} ${r}`, `margin ${e} ${t}`, `color ${e}`].join(","),
        "+ span": {
          marginInlineStart: d,
          opacity: 1,
          transition: [`opacity ${e} ${t}`, `margin ${e}`, `color ${e}`].join(",")
        }
      },
      [`${a}-item-icon`]: Object.assign({}, j()),
      [`&${a}-item-only-child`]: {
        [`> ${i}, > ${a}-item-icon`]: {
          marginInlineEnd: 0
        }
      }
    },
    // Disabled state sets text to gray and nukes hover/tab effects
    [`${a}-item-disabled, ${a}-submenu-disabled`]: {
      background: "none !important",
      cursor: "not-allowed",
      "&::after": {
        borderColor: "transparent !important"
      },
      a: {
        color: "inherit !important"
      },
      [`> ${a}-submenu-title`]: {
        color: "inherit !important",
        cursor: "not-allowed"
      }
    }
  };
}, M = (n) => {
  const {
    componentCls: a,
    motionDurationSlow: e,
    motionEaseInOut: o,
    borderRadius: t,
    menuArrowSize: r,
    menuArrowOffset: i
  } = n;
  return {
    [`${a}-submenu`]: {
      "&-expand-icon, &-arrow": {
        position: "absolute",
        top: "50%",
        insetInlineEnd: n.margin,
        width: r,
        color: "currentcolor",
        transform: "translateY(-50%)",
        transition: `transform ${e} ${o}, opacity ${e}`
      },
      "&-arrow": {
        // →
        "&::before, &::after": {
          position: "absolute",
          width: r * 0.6,
          height: r * 0.15,
          backgroundColor: "currentcolor",
          borderRadius: t,
          transition: [`background ${e} ${o}`, `transform ${e} ${o}`, `top ${e} ${o}`, `color ${e} ${o}`].join(","),
          content: '""'
        },
        "&::before": {
          transform: `rotate(45deg) translateY(-${i})`
        },
        "&::after": {
          transform: `rotate(-45deg) translateY(${i})`
        }
      }
    }
  };
}, F = (n) => {
  const {
    antCls: a,
    componentCls: e,
    fontSize: o,
    motionDurationSlow: t,
    motionDurationMid: r,
    motionEaseInOut: i,
    paddingXS: m,
    padding: d,
    colorSplit: b,
    lineWidth: s,
    zIndexPopup: u,
    borderRadiusLG: p,
    subMenuItemBorderRadius: $,
    menuArrowSize: S,
    menuArrowOffset: c,
    lineType: B,
    menuPanelMaskInset: g,
    groupTitleLineHeight: h,
    groupTitleFontSize: f
  } = n;
  return [
    // Misc
    {
      "": {
        [`${e}`]: Object.assign(Object.assign({}, z()), {
          // Hidden
          "&-hidden": {
            display: "none"
          }
        })
      },
      [`${e}-submenu-hidden`]: {
        display: "none"
      }
    },
    {
      [e]: Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, R(n)), z()), {
        marginBottom: 0,
        paddingInlineStart: 0,
        // Override default ul/ol
        fontSize: o,
        lineHeight: 0,
        listStyle: "none",
        outline: "none",
        // Magic cubic here but smooth transition
        transition: `width ${t} cubic-bezier(0.2, 0, 0, 1) 0s`,
        "ul, ol": {
          margin: 0,
          padding: 0,
          listStyle: "none"
        },
        // Overflow ellipsis
        "&-overflow": {
          display: "flex",
          [`${e}-item`]: {
            flex: "none"
          }
        },
        [`${e}-item, ${e}-submenu, ${e}-submenu-title`]: {
          borderRadius: n.itemBorderRadius
        },
        [`${e}-item-group-title`]: {
          padding: `${m}px ${d}px`,
          fontSize: f,
          lineHeight: h,
          transition: `all ${t}`
        },
        [`&-horizontal ${e}-submenu`]: {
          transition: [`border-color ${t} ${i}`, `background ${t} ${i}`].join(",")
        },
        [`${e}-submenu, ${e}-submenu-inline`]: {
          transition: [`border-color ${t} ${i}`, `background ${t} ${i}`, `padding ${r} ${i}`].join(",")
        },
        [`${e}-submenu ${e}-sub`]: {
          cursor: "initial",
          transition: [`background ${t} ${i}`, `padding ${t} ${i}`].join(",")
        },
        [`${e}-title-content`]: {
          transition: `color ${t}`,
          // https://github.com/ant-design/ant-design/issues/41143
          [`> ${a}-typography-ellipsis-single-line`]: {
            display: "inline",
            verticalAlign: "unset"
          }
        },
        [`${e}-item a`]: {
          "&::before": {
            position: "absolute",
            inset: 0,
            backgroundColor: "transparent",
            content: '""'
          }
        },
        // Removed a Badge related style seems it's safe
        // https://github.com/ant-design/ant-design/issues/19809
        // >>>>> Divider
        [`${e}-item-divider`]: {
          overflow: "hidden",
          lineHeight: 0,
          borderColor: b,
          borderStyle: B,
          borderWidth: 0,
          borderTopWidth: s,
          marginBlock: s,
          padding: 0,
          "&-dashed": {
            borderStyle: "dashed"
          }
        }
      }), A(n)), {
        [`${e}-item-group`]: {
          [`${e}-item-group-list`]: {
            margin: 0,
            padding: 0,
            [`${e}-item, ${e}-submenu-title`]: {
              paddingInline: `${o * 2}px ${d}px`
            }
          }
        },
        // ======================= Sub Menu =======================
        "&-submenu": {
          "&-popup": {
            position: "absolute",
            zIndex: u,
            borderRadius: p,
            boxShadow: "none",
            transformOrigin: "0 0",
            [`&${e}-submenu`]: {
              background: "transparent"
            },
            // https://github.com/ant-design/ant-design/issues/13955
            "&::before": {
              position: "absolute",
              inset: `${g}px 0 0`,
              zIndex: -1,
              width: "100%",
              height: "100%",
              opacity: 0,
              content: '""'
            }
          },
          // https://github.com/ant-design/ant-design/issues/13955
          "&-placement-rightTop::before": {
            top: 0,
            insetInlineStart: g
          },
          "\n          &-placement-leftTop,\n          &-placement-bottomRight,\n          ": {
            transformOrigin: "100% 0"
          },
          "\n          &-placement-leftBottom,\n          &-placement-topRight,\n          ": {
            transformOrigin: "100% 100%"
          },
          "\n          &-placement-rightBottom,\n          &-placement-topLeft,\n          ": {
            transformOrigin: "0 100%"
          },
          "\n          &-placement-bottomLeft,\n          &-placement-rightTop,\n          ": {
            transformOrigin: "0 0"
          },
          "\n          &-placement-leftTop,\n          &-placement-leftBottom\n          ": {
            paddingInlineEnd: n.paddingXS
          },
          "\n          &-placement-rightTop,\n          &-placement-rightBottom\n          ": {
            paddingInlineStart: n.paddingXS
          },
          "\n          &-placement-topRight,\n          &-placement-topLeft\n          ": {
            paddingBottom: n.paddingXS
          },
          "\n          &-placement-bottomRight,\n          &-placement-bottomLeft\n          ": {
            paddingTop: n.paddingXS
          },
          [`> ${e}`]: Object.assign(Object.assign(Object.assign({
            borderRadius: p
          }, A(n)), M(n)), {
            [`${e}-item, ${e}-submenu > ${e}-submenu-title`]: {
              borderRadius: $
            },
            [`${e}-submenu-title::after`]: {
              transition: `transform ${t} ${i}`
            }
          })
        }
      }), M(n)), {
        [`&-inline-collapsed ${e}-submenu-arrow,
        &-inline ${e}-submenu-arrow`]: {
          // ↓
          "&::before": {
            transform: `rotate(-45deg) translateX(${c})`
          },
          "&::after": {
            transform: `rotate(45deg) translateX(-${c})`
          }
        },
        [`${e}-submenu-open${e}-submenu-inline > ${e}-submenu-title > ${e}-submenu-arrow`]: {
          // ↑
          transform: `translateY(-${S * 0.2}px)`,
          "&::after": {
            transform: `rotate(-45deg) translateX(-${c})`
          },
          "&::before": {
            transform: `rotate(45deg) translateX(${c})`
          }
        }
      })
    },
    // Integration with header element so menu items have the same height
    {
      [`${a}-layout-header`]: {
        [e]: {
          lineHeight: "inherit"
        }
      }
    }
  ];
}, ge = (n, a) => E("Menu", (o) => {
  if (a === !1)
    return [];
  const {
    colorBgElevated: t,
    colorPrimary: r,
    colorTextLightSolid: i,
    controlHeightLG: m,
    fontSize: d,
    darkItemColor: b,
    darkDangerItemColor: s,
    darkItemBg: u,
    darkSubMenuItemBg: p,
    darkItemSelectedColor: $,
    darkItemSelectedBg: S,
    darkDangerItemSelectedBg: c,
    darkItemHoverBg: B,
    darkGroupTitleColor: g,
    darkItemHoverColor: h,
    darkItemDisabledColor: f,
    darkDangerItemHoverColor: H,
    darkDangerItemSelectedColor: T,
    darkDangerItemActiveBg: v
  } = o, C = d / 7 * 5, l = k(o, {
    menuArrowSize: C,
    menuHorizontalHeight: m * 1.15,
    menuArrowOffset: `${C * 0.25}px`,
    menuPanelMaskInset: -7,
    menuSubMenuBg: t
  }), I = k(l, {
    itemColor: b,
    itemHoverColor: h,
    groupTitleColor: g,
    itemSelectedColor: $,
    itemBg: u,
    popupBg: u,
    subMenuItemBg: p,
    itemActiveBg: "transparent",
    itemSelectedBg: S,
    activeBarHeight: 0,
    activeBarBorderWidth: 0,
    itemHoverBg: B,
    // Disabled
    itemDisabledColor: f,
    // Danger
    dangerItemColor: s,
    dangerItemHoverColor: H,
    dangerItemSelectedColor: T,
    dangerItemActiveBg: v,
    dangerItemSelectedBg: c,
    menuSubMenuBg: p,
    // Horizontal
    horizontalItemSelectedColor: i,
    horizontalItemSelectedBg: r
  });
  return [
    // Basic
    F(l),
    // Horizontal
    X(l),
    // Vertical
    P(l),
    // Theme
    w(l, "light"),
    w(I, "dark"),
    // RTL
    G(l),
    // Motion
    W(l),
    D(l, "slide-up"),
    D(l, "slide-down"),
    L(l, "zoom-big")
  ];
}, (o) => {
  const {
    colorPrimary: t,
    colorError: r,
    colorTextDisabled: i,
    colorErrorBg: m,
    colorText: d,
    colorTextDescription: b,
    colorBgContainer: s,
    colorFillAlter: u,
    colorFillContent: p,
    lineWidth: $,
    lineWidthBold: S,
    controlItemBgActive: c,
    colorBgTextHover: B,
    controlHeightLG: g,
    lineHeight: h,
    colorBgElevated: f,
    marginXXS: H,
    padding: T,
    fontSize: v,
    controlHeightSM: C,
    fontSizeLG: l,
    colorTextLightSolid: I,
    colorErrorHover: O
  } = o, x = new y(I).setAlpha(0.65).toRgbString();
  return {
    dropdownWidth: 160,
    zIndexPopup: o.zIndexPopupBase + 50,
    radiusItem: o.borderRadiusLG,
    itemBorderRadius: o.borderRadiusLG,
    radiusSubMenuItem: o.borderRadiusSM,
    subMenuItemBorderRadius: o.borderRadiusSM,
    colorItemText: d,
    itemColor: d,
    colorItemTextHover: d,
    itemHoverColor: d,
    colorItemTextHoverHorizontal: t,
    horizontalItemHoverColor: t,
    colorGroupTitle: b,
    groupTitleColor: b,
    colorItemTextSelected: t,
    itemSelectedColor: t,
    colorItemTextSelectedHorizontal: t,
    horizontalItemSelectedColor: t,
    colorItemBg: s,
    itemBg: s,
    colorItemBgHover: B,
    itemHoverBg: B,
    colorItemBgActive: p,
    itemActiveBg: c,
    colorSubItemBg: u,
    subMenuItemBg: u,
    colorItemBgSelected: c,
    itemSelectedBg: c,
    colorItemBgSelectedHorizontal: "transparent",
    horizontalItemSelectedBg: "transparent",
    colorActiveBarWidth: 0,
    activeBarWidth: 0,
    colorActiveBarHeight: S,
    activeBarHeight: S,
    colorActiveBarBorderSize: $,
    activeBarBorderWidth: $,
    // Disabled
    colorItemTextDisabled: i,
    itemDisabledColor: i,
    // Danger
    colorDangerItemText: r,
    dangerItemColor: r,
    colorDangerItemTextHover: r,
    dangerItemHoverColor: r,
    colorDangerItemTextSelected: r,
    dangerItemSelectedColor: r,
    colorDangerItemBgActive: m,
    dangerItemActiveBg: m,
    colorDangerItemBgSelected: m,
    dangerItemSelectedBg: m,
    itemMarginInline: o.marginXXS,
    horizontalItemBorderRadius: 0,
    horizontalItemHoverBg: "transparent",
    itemHeight: g,
    groupTitleLineHeight: h,
    collapsedWidth: g * 2,
    popupBg: f,
    itemMarginBlock: H,
    itemPaddingInline: T,
    horizontalLineHeight: `${g * 1.15}px`,
    iconSize: v,
    iconMarginInlineEnd: C - v,
    collapsedIconSize: l,
    groupTitleFontSize: v,
    // Disabled
    darkItemDisabledColor: new y(I).setAlpha(0.25).toRgbString(),
    // Dark
    darkItemColor: x,
    darkDangerItemColor: r,
    darkItemBg: "#001529",
    darkSubMenuItemBg: "#000c17",
    darkItemSelectedColor: I,
    darkItemSelectedBg: t,
    darkDangerItemSelectedBg: r,
    darkItemHoverBg: "transparent",
    darkGroupTitleColor: x,
    darkItemHoverColor: I,
    darkDangerItemHoverColor: O,
    darkDangerItemSelectedColor: I,
    darkDangerItemActiveBg: r
  };
}, {
  deprecatedTokens: [["colorGroupTitle", "groupTitleColor"], ["radiusItem", "itemBorderRadius"], ["radiusSubMenuItem", "subMenuItemBorderRadius"], ["colorItemText", "itemColor"], ["colorItemTextHover", "itemHoverColor"], ["colorItemTextHoverHorizontal", "horizontalItemHoverColor"], ["colorItemTextSelected", "itemSelectedColor"], ["colorItemTextSelectedHorizontal", "horizontalItemSelectedColor"], ["colorItemTextDisabled", "itemDisabledColor"], ["colorDangerItemText", "dangerItemColor"], ["colorDangerItemTextHover", "dangerItemHoverColor"], ["colorDangerItemTextSelected", "dangerItemSelectedColor"], ["colorDangerItemBgActive", "dangerItemActiveBg"], ["colorDangerItemBgSelected", "dangerItemSelectedBg"], ["colorItemBg", "itemBg"], ["colorItemBgHover", "itemHoverBg"], ["colorSubItemBg", "subMenuItemBg"], ["colorItemBgActive", "itemActiveBg"], ["colorItemBgSelectedHorizontal", "horizontalItemSelectedBg"], ["colorActiveBarWidth", "activeBarWidth"], ["colorActiveBarHeight", "activeBarHeight"], ["colorActiveBarBorderSize", "activeBarBorderWidth"], ["colorItemBgSelected", "itemSelectedBg"]]
})(n);
export {
  ge as default
};
