import { resetComponent as a, genFocusStyle as n } from "../../style/index.mjs";
import { initFadeMotion as t } from "../../style/motion/fade.mjs";
import { initZoomMotion as l } from "../../style/motion/zoom.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import m from "../../theme/util/genComponentStyleHook.mjs";
import { merge as p } from "../../theme/util/statistic.mjs";
function d(o) {
  return {
    position: o,
    inset: 0
  };
}
const g = (o) => {
  const {
    componentCls: r,
    antCls: i
  } = o;
  return [{
    [`${r}-root`]: {
      [`${r}${i}-zoom-enter, ${r}${i}-zoom-appear`]: {
        // reset scale avoid mousePosition bug
        transform: "none",
        opacity: 0,
        animationDuration: o.motionDurationSlow,
        // https://github.com/ant-design/ant-design/issues/11777
        userSelect: "none"
      },
      // https://github.com/ant-design/ant-design/issues/37329
      // https://github.com/ant-design/ant-design/issues/40272
      [`${r}${i}-zoom-leave ${r}-content`]: {
        pointerEvents: "none"
      },
      [`${r}-mask`]: Object.assign(Object.assign({}, d("fixed")), {
        zIndex: o.zIndexPopupBase,
        height: "100%",
        backgroundColor: o.colorBgMask,
        pointerEvents: "none",
        [`${r}-hidden`]: {
          display: "none"
        }
      }),
      [`${r}-wrap`]: Object.assign(Object.assign({}, d("fixed")), {
        zIndex: o.zIndexPopupBase,
        overflow: "auto",
        outline: 0,
        WebkitOverflowScrolling: "touch",
        // Note: Firefox not support `:has` yet
        [`&:has(${r}${i}-zoom-enter), &:has(${r}${i}-zoom-appear)`]: {
          pointerEvents: "none"
        }
      })
    }
  }, {
    [`${r}-root`]: t(o)
  }];
}, c = (o) => {
  const {
    componentCls: r
  } = o;
  return [
    // ======================== Root =========================
    {
      [`${r}-root`]: {
        [`${r}-wrap-rtl`]: {
          direction: "rtl"
        },
        [`${r}-centered`]: {
          textAlign: "center",
          "&::before": {
            display: "inline-block",
            width: 0,
            height: "100%",
            verticalAlign: "middle",
            content: '""'
          },
          [r]: {
            top: 0,
            display: "inline-block",
            paddingBottom: 0,
            textAlign: "start",
            verticalAlign: "middle"
          }
        },
        [`@media (max-width: ${o.screenSMMax})`]: {
          [r]: {
            maxWidth: "calc(100vw - 16px)",
            margin: `${o.marginXS} auto`
          },
          [`${r}-centered`]: {
            [r]: {
              flex: 1
            }
          }
        }
      }
    },
    // ======================== Modal ========================
    {
      [r]: Object.assign(Object.assign({}, a(o)), {
        pointerEvents: "none",
        position: "relative",
        top: 100,
        width: "auto",
        maxWidth: `calc(100vw - ${o.margin * 2}px)`,
        margin: "0 auto",
        paddingBottom: o.paddingLG,
        [`${r}-title`]: {
          margin: 0,
          color: o.titleColor,
          fontWeight: o.fontWeightStrong,
          fontSize: o.titleFontSize,
          lineHeight: o.titleLineHeight,
          wordWrap: "break-word"
        },
        [`${r}-content`]: {
          position: "relative",
          backgroundColor: o.contentBg,
          backgroundClip: "padding-box",
          border: 0,
          borderRadius: o.borderRadiusLG,
          boxShadow: o.boxShadow,
          pointerEvents: "auto",
          padding: `${o.paddingMD}px ${o.paddingContentHorizontalLG}px`
        },
        [`${r}-close`]: Object.assign({
          position: "absolute",
          top: (o.modalHeaderHeight - o.modalCloseBtnSize) / 2,
          insetInlineEnd: (o.modalHeaderHeight - o.modalCloseBtnSize) / 2,
          zIndex: o.zIndexPopupBase + 10,
          padding: 0,
          color: o.modalCloseIconColor,
          fontWeight: o.fontWeightStrong,
          lineHeight: 1,
          textDecoration: "none",
          background: "transparent",
          borderRadius: o.borderRadiusSM,
          width: o.modalCloseBtnSize,
          height: o.modalCloseBtnSize,
          border: 0,
          outline: 0,
          cursor: "pointer",
          transition: `color ${o.motionDurationMid}, background-color ${o.motionDurationMid}`,
          "&-x": {
            display: "flex",
            fontSize: o.fontSizeLG,
            fontStyle: "normal",
            lineHeight: `${o.modalCloseBtnSize}px`,
            justifyContent: "center",
            textTransform: "none",
            textRendering: "auto"
          },
          "&:hover": {
            color: o.modalIconHoverColor,
            backgroundColor: o.wireframe ? "transparent" : o.colorFillContent,
            textDecoration: "none"
          },
          "&:active": {
            backgroundColor: o.wireframe ? "transparent" : o.colorFillContentHover
          }
        }, n(o)),
        [`${r}-header`]: {
          color: o.colorText,
          background: o.headerBg,
          borderRadius: `${o.borderRadiusLG}px ${o.borderRadiusLG}px 0 0`,
          marginBottom: o.marginXS
        },
        [`${r}-body`]: {
          fontSize: o.fontSize,
          lineHeight: o.lineHeight,
          wordWrap: "break-word"
        },
        [`${r}-footer`]: {
          textAlign: "end",
          background: o.footerBg,
          marginTop: o.marginSM,
          [`${o.antCls}-btn + ${o.antCls}-btn:not(${o.antCls}-dropdown-trigger)`]: {
            marginBottom: 0,
            marginInlineStart: o.marginXS
          }
        },
        [`${r}-open`]: {
          overflow: "hidden"
        }
      })
    },
    // ======================== Pure =========================
    {
      [`${r}-pure-panel`]: {
        top: "auto",
        padding: 0,
        display: "flex",
        flexDirection: "column",
        [`${r}-content,
          ${r}-body,
          ${r}-confirm-body-wrapper`]: {
          display: "flex",
          flexDirection: "column",
          flex: "auto"
        },
        [`${r}-confirm-body`]: {
          marginBottom: "auto"
        }
      }
    }
  ];
}, s = (o) => {
  const {
    componentCls: r,
    antCls: i
  } = o, e = `${r}-confirm`;
  return {
    [r]: {
      [`${r}-content`]: {
        padding: 0
      },
      [`${r}-header`]: {
        padding: o.modalHeaderPadding,
        borderBottom: `${o.modalHeaderBorderWidth}px ${o.modalHeaderBorderStyle} ${o.modalHeaderBorderColorSplit}`,
        marginBottom: 0
      },
      [`${r}-body`]: {
        padding: o.modalBodyPadding
      },
      [`${r}-footer`]: {
        padding: `${o.modalFooterPaddingVertical}px ${o.modalFooterPaddingHorizontal}px`,
        borderTop: `${o.modalFooterBorderWidth}px ${o.modalFooterBorderStyle} ${o.modalFooterBorderColorSplit}`,
        borderRadius: `0 0 ${o.borderRadiusLG}px ${o.borderRadiusLG}px`,
        marginTop: 0
      }
    },
    [e]: {
      [`${i}-modal-body`]: {
        padding: `${o.padding * 2}px ${o.padding * 2}px ${o.paddingLG}px`
      },
      [`${e}-body > ${o.iconCls}`]: {
        marginInlineEnd: o.margin
      },
      [`${e}-btns`]: {
        marginTop: o.marginLG
      }
    }
  };
}, $ = (o) => {
  const {
    componentCls: r
  } = o;
  return {
    [`${r}-root`]: {
      [`${r}-wrap-rtl`]: {
        direction: "rtl",
        [`${r}-confirm-body`]: {
          direction: "rtl"
        }
      }
    }
  };
}, u = (o) => {
  const r = o.padding, i = o.fontSizeHeading5, e = o.lineHeightHeading5;
  return p(o, {
    modalBodyPadding: o.paddingLG,
    modalHeaderPadding: `${r}px ${o.paddingLG}px`,
    modalHeaderBorderWidth: o.lineWidth,
    modalHeaderBorderStyle: o.lineType,
    modalHeaderBorderColorSplit: o.colorSplit,
    modalHeaderHeight: e * i + r * 2,
    modalFooterBorderColorSplit: o.colorSplit,
    modalFooterBorderStyle: o.lineType,
    modalFooterPaddingVertical: o.paddingXS,
    modalFooterPaddingHorizontal: o.padding,
    modalFooterBorderWidth: o.lineWidth,
    modalIconHoverColor: o.colorIconHover,
    modalCloseIconColor: o.colorIcon,
    modalCloseBtnSize: o.fontSize * o.lineHeight,
    modalConfirmIconSize: o.fontSize * o.lineHeight
  });
}, b = (o) => ({
  footerBg: "transparent",
  headerBg: o.colorBgElevated,
  titleLineHeight: o.lineHeightHeading5,
  titleFontSize: o.fontSizeHeading5,
  contentBg: o.colorBgElevated,
  titleColor: o.colorTextHeading
}), M = m("Modal", (o) => {
  const r = u(o);
  return [c(r), $(r), g(r), o.wireframe && s(r), l(r, "zoom")];
}, b);
export {
  M as default,
  g as genModalMaskStyle,
  b as prepareComponentToken,
  u as prepareToken
};
