import { resetIcon as p } from "../../style/index.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import { merge as d } from "../../theme/util/statistic.mjs";
const n = 2, c = (i) => {
  let {
    multipleSelectItemHeight: t,
    selectHeight: e,
    lineWidth: o
  } = i;
  const l = (e - t) / 2 - o, r = Math.ceil(l / 2);
  return [l, r];
};
function a(i, t) {
  const {
    componentCls: e,
    iconCls: o
  } = i, l = `${e}-selection-overflow`, r = i.multipleSelectItemHeight, [s] = c(i), m = t ? `${e}-${t}` : "";
  return {
    [`${e}-multiple${m}`]: {
      fontSize: i.fontSize,
      /**
       * Do not merge `height` & `line-height` under style with `selection` & `search`, since chrome
       * may update to redesign with its align logic.
       */
      // =========================== Overflow ===========================
      [l]: {
        position: "relative",
        display: "flex",
        flex: "auto",
        flexWrap: "wrap",
        maxWidth: "100%",
        "&-item": {
          flex: "none",
          alignSelf: "center",
          maxWidth: "100%",
          display: "inline-flex"
        }
      },
      // ========================= Selector =========================
      [`${e}-selector`]: {
        display: "flex",
        flexWrap: "wrap",
        alignItems: "center",
        height: "100%",
        // Multiple is little different that horizontal is follow the vertical
        padding: `${s - n}px ${n * 2}px`,
        borderRadius: i.borderRadius,
        [`${e}-show-search&`]: {
          cursor: "text"
        },
        [`${e}-disabled&`]: {
          background: i.multipleSelectorBgDisabled,
          cursor: "not-allowed"
        },
        "&:after": {
          display: "inline-block",
          width: 0,
          margin: `${n}px 0`,
          lineHeight: `${r}px`,
          visibility: "hidden",
          content: '"\\a0"'
        }
      },
      [`
        &${e}-show-arrow ${e}-selector,
        &${e}-allow-clear ${e}-selector
      `]: {
        paddingInlineEnd: i.fontSizeIcon + i.controlPaddingHorizontal
      },
      // ======================== Selections ========================
      [`${e}-selection-item`]: {
        display: "flex",
        alignSelf: "center",
        flex: "none",
        boxSizing: "border-box",
        maxWidth: "100%",
        height: r,
        marginTop: n,
        marginBottom: n,
        lineHeight: `${r - i.lineWidth * 2}px`,
        background: i.multipleItemBg,
        border: `${i.lineWidth}px ${i.lineType} ${i.multipleItemBorderColor}`,
        borderRadius: i.borderRadiusSM,
        cursor: "default",
        transition: `font-size ${i.motionDurationSlow}, line-height ${i.motionDurationSlow}, height ${i.motionDurationSlow}`,
        marginInlineEnd: n * 2,
        paddingInlineStart: i.paddingXS,
        paddingInlineEnd: i.paddingXS / 2,
        [`${e}-disabled&`]: {
          color: i.multipleItemColorDisabled,
          borderColor: i.multipleItemBorderColorDisabled,
          cursor: "not-allowed"
        },
        // It's ok not to do this, but 24px makes bottom narrow in view should adjust
        "&-content": {
          display: "inline-block",
          marginInlineEnd: i.paddingXS / 2,
          overflow: "hidden",
          whiteSpace: "pre",
          textOverflow: "ellipsis"
        },
        "&-remove": Object.assign(Object.assign({}, p()), {
          display: "inline-flex",
          alignItems: "center",
          color: i.colorIcon,
          fontWeight: "bold",
          fontSize: 10,
          lineHeight: "inherit",
          cursor: "pointer",
          [`> ${o}`]: {
            verticalAlign: "-0.2em"
          },
          "&:hover": {
            color: i.colorIconHover
          }
        })
      },
      // ========================== Input ==========================
      [`${l}-item + ${l}-item`]: {
        [`${e}-selection-search`]: {
          marginInlineStart: 0
        }
      },
      // https://github.com/ant-design/ant-design/issues/44754
      [`${l}-item-suffix`]: {
        height: "100%"
      },
      [`${e}-selection-search`]: {
        display: "inline-flex",
        position: "relative",
        maxWidth: "100%",
        marginInlineStart: i.inputPaddingHorizontalBase - s,
        "\n          &-input,\n          &-mirror\n        ": {
          height: r,
          fontFamily: i.fontFamily,
          lineHeight: `${r}px`,
          transition: `all ${i.motionDurationSlow}`
        },
        "&-input": {
          width: "100%",
          minWidth: 4.1
          // fix search cursor missing
        },
        "&-mirror": {
          position: "absolute",
          top: 0,
          insetInlineStart: 0,
          insetInlineEnd: "auto",
          zIndex: 999,
          whiteSpace: "pre",
          visibility: "hidden"
        }
      },
      // ======================= Placeholder =======================
      [`${e}-selection-placeholder`]: {
        position: "absolute",
        top: "50%",
        insetInlineStart: i.inputPaddingHorizontalBase,
        insetInlineEnd: i.inputPaddingHorizontalBase,
        transform: "translateY(-50%)",
        transition: `all ${i.motionDurationSlow}`
      }
    }
  };
}
const g = (i) => {
  const {
    componentCls: t
  } = i, e = d(i, {
    selectHeight: i.controlHeightSM,
    multipleSelectItemHeight: i.controlHeightXS,
    borderRadius: i.borderRadiusSM,
    borderRadiusSM: i.borderRadiusXS
  }), o = d(i, {
    fontSize: i.fontSizeLG,
    selectHeight: i.controlHeightLG,
    multipleSelectItemHeight: i.multipleItemHeightLG,
    borderRadius: i.borderRadiusLG,
    borderRadiusSM: i.borderRadius
  }), [, l] = c(i);
  return [
    a(i),
    // ======================== Small ========================
    a(e, "sm"),
    // Padding
    {
      [`${t}-multiple${t}-sm`]: {
        [`${t}-selection-placeholder`]: {
          insetInline: i.controlPaddingHorizontalSM - i.lineWidth
        },
        // https://github.com/ant-design/ant-design/issues/29559
        [`${t}-selection-search`]: {
          marginInlineStart: l
        }
      }
    },
    // ======================== Large ========================
    a(o, "lg")
  ];
}, M = g;
export {
  M as default
};
