import { type FC } from "react";
import type { BreadcrumbProps, TagType, AvatarProps } from 'antd';
import { Breadcrumb } from "antd";
import './index.less';
export interface BitzPageHeaderProps {
    prefixCls?: string;
    /**
     * 自定义 back icon ，如果为 false 不渲染 back icon
     */
    backIcon?: React.ReactNode;
    /**
     * 自定义标题文字
     */
    title?: React.ReactNode;
    /**
     * 自定义的二级标题文字
     */
    subTitle?: React.ReactNode;
    style?: React.CSSProperties;
    childrenContentStyle?: React.CSSProperties;
    /**
     * 面包屑的配置
     */
    breadcrumb?: Partial<BreadcrumbProps> | React.ReactElement<typeof Breadcrumb>;
    /**
     * breadcrumbRender
     * @param props
     * @param defaultDom
     */
    breadcrumbRender?: (props: BitzPageHeaderProps, defaultDom: React.ReactNode) => React.ReactNode;
    /**
     * title 旁的 tag 列表
     */
    tags?: React.ReactElement<TagType> | React.ReactElement<TagType>[];
    /**
     * PageHeader 的页脚，一般用于渲染 TabBar
     */
    footer?: React.ReactNode;
    /**
     * 操作区，位于 title 行的行尾
     */
    extra?: React.ReactNode;
    /**
     * 标题栏旁的头像
     */
    avatar?: AvatarProps;
    /**
     * 返回按钮的点击事件
     */
    onBack?: (e?: React.MouseEvent<HTMLElement>) => void;
    className?: string;
    contentWidth?: 'Fluid' | 'Fixed';
    /**
     * pageHeader 的类型，将会改变背景颜色
     */
    ghost?: boolean;
    children?: React.ReactNode;
}
declare const BitzPageHeader: FC<BitzPageHeaderProps>;
export default BitzPageHeader;
