import { FC } from 'react';
import './index.less';
interface BitzTableProps {
    /**
     *
     * @param val H5列表数据回显
     * @returns
     */
    tableItemEmit?: (val: any) => void;
    /**
     * 是否显示分页
     */
    showPagination?: boolean;
    /**
     * 后端返回的数组数据，适用PC与H5,不需要再处理
     */
    dataSource?: any[];
    /**
     * 总数
     */
    total?: number;
    /**
     * 自定义的列表参数，同一个列表参数同时匹配PC与H5
     */
    columns?: any;
    /**
     * 操作按钮数组
     */
    operations?: any;
    /**
     * 表格行key的取值
     */
    rowKey?: string;
    /**
     * Table的加载状态
     */
    loading?: boolean;
    /**
     * 移动端操作按钮返回函数
     */
    tableOperationEmit?: (type: string, item: any) => void;
    /**
     * PC的Table多选返回函数，例如全选/多选
     */
    tableSelectEmit?: (val: any) => void;
    /**
     * PC的Table控制全选/多选开关
     */
    showSelect?: boolean;
    /**
     * 移动端加载更多返回函数
     */
    mobileLoadEmit?: () => void;
    /**
     * 移动端的下拉刷新
     */
    mobileRefreshEmit?: () => void;
    /**
     * 是否显示tableNav
     */
    showTableNav?: boolean;
    /**
     * 指定树形结构的列名
     */
    childrenColumnName?: string;
    /**
     * 初始时，是否展开所有行
     */
    defaultExpandAllRows?: boolean;
    /**
     * 给父组件传值 page当前第几页  pageSize每页有多少
     */
    paginationEmit?: (page: number, pageSize: number) => void;
}
declare const BitzTable: FC<BitzTableProps>;
export default BitzTable;
